#!/bin/sh

cfgnam=$1
parnam=$2
parold=$3
parnew=$4
interfaces=/etc/network/interfaces
mrsystem=/etc/mrsystem
mrstart=/etc/init.d/mrsystem
rocraild=/etc/init.d/rocraild
starttok="start-stop-daemon --start --background --exec \$DAEMONPATH/"


to_static() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^# *\(iface eth0 inet static\);\1;' \
		-e "s;^# *\(address $address\);\1;" \
		-e "s;^# *\(netmask $netmask\);\1;" \
		-e "s;^# *\(network $network\);\1;" \
		-e "s;^# *\(gateway $gateway\);\1;" \
		-e 's;^\(iface eth0 inet dhcp\);# \1;' $interfaces
}

to_dhcp() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^\(iface eth0 inet static\);# \1;' \
		-e "s;^ *\(address $address\);#\1;" \
		-e "s;^ *\(netmask $netmask\);#\1;" \
		-e "s;^ *\(network $network\);#\1;" \
		-e "s;^ *\(gateway $gateway\);#\1;" \
		-e 's;^# *\(iface eth0 inet dhcp\);\1;' $interfaces
}

chg_calue() {
	sudo sed -i \
		-e "s;^ *\($1 $2\);$1 $3;" \
		-e "s;^# *\($1 $2\);#$1 $3;" $interfaces
}

chg_int_mrsystem() {
	sudo sed -i -e "s;^\($1 $2\);$1 $3;" $mrsystem
}

chg_txt_mrsystem() {
	sudo sed -i -e "s;^\($1 \"$2\"\);$1 \"$3\";" $mrsystem
}

chg_ip_mrsystem() {
	oip1=`echo $parold | cut -f 1 -d "."`
	oip2=`echo $parold | cut -f 2 -d "."`
	oip3=`echo $parold | cut -f 3 -d "."`
	oip4=`echo $parold | cut -f 4 -d "."`
	nip1=`echo $parnew | cut -f 1 -d "."`
	nip2=`echo $parnew | cut -f 2 -d "."`
	nip3=`echo $parnew | cut -f 3 -d "."`
	nip4=`echo $parnew | cut -f 4 -d "."`
	sudo sed -i -r -e "s;^$1 \"$oip1\.$oip2\.$oip3\.$oip4\";$1 \"$nip1\.$nip2\.$nip3\.$nip4\";" $mrsystem
}

enable_start() {
	sudo sed -i -e "s;^#\t$starttok$1;\t$starttok$1;" $mrstart
}

enable_stop() {
	sudo sed -i -e "s;^#\tkillall $1;\tkillall $1;" $mrstart
}

disable_start() {
	sudo sed -i -e "s;^\t$starttok$1;#\t$starttok$1;" $mrstart
}

disable_stop() {
	sudo sed -i -e "s;^\tkillall $1;#\tkillall $1;" $mrstart
}


if [ $cfgnam = "sysconfig" ] ; then
	if [ $parnam = "linux-dhcp" ] ; then
		if [ $parnew = "off" ] ; then
			to_static
		elif [ $parnew = "on" ] ; then
			to_dhcp
		fi
	elif [ $parnam = "linux-ipadress" ] ; then
		chg_calue address $parold $parnew
	elif [ $parnam = "linux-netmask" ] ; then
		chg_calue netmask $parold $parnew
	elif [ $parnam = "linux-network" ] ; then
		chg_calue network $parold $parnew
	elif [ $parnam = "linux-gateway" ] ; then
		chg_calue gateway $parold $parnew
	elif [ $parnam = "zentrale" ] ; then
		chg_int_mrsystem zentrale $parold $parnew
	elif [ $parnam = "broadcast" ] ; then
		if [ $parold = "off" ] ; then
			if [ $parnew = "off" ] ; then
				to_static
				chg_int_mrsystem broadcast 0 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 0 1
			fi
			elif [ $parold = "on" ] ; then
			if [ $parnew = "off" ] ; then
				chg_int_mrsystem broadcast 1 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 1 1
			fi
		fi
	elif [ $parnam = "udpbc" ] ; then
		chg_ip_mrsystem udpbc $parold $parnew
	elif [ $parnam = "address" ] ; then
		chg_ip_mrsystem address $parold $parnew
	elif [ $parnam = "port" ] ; then
		chg_int_mrsystem port $parold $parnew
	elif [ $parnam = "interface" ] ; then
		chg_txt_mrsystem interface $parold $parnew
	elif [ $parnam = "can_interface" ] ; then
		chg_txt_mrsystem can_interface $parold $parnew
	elif [ $parnam = "cs2_path" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
	elif [ $parnam = "protokoll" ] ; then
		chg_int_mrsystem protokoll $parold $parnew
	elif [ $parnam = "gleissignal" ] ; then
		chg_txt_mrsystem gleissignal $parold $parnew
	elif [ $parnam = "conn_tcp" ] ; then
		chg_int_mrsystem conn_tcp $parold $parnew
	elif [ $parnam = "wakeup_s88" ] ; then
		chg_int_mrsystem wakeup_s88 $parold $parnew
	elif [ $parnam = "gpio_s88" ] ; then
		chg_txt_mrsystem gpio_s88 "$parold" "$parnew"
	elif [ $parnam = "update_file" ] ; then
		full_name="/home/developer/updates/"$parnew
		sudo /usr/local/bin/mrupdate $full_name
	elif [ $parnam = "reboot" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
		if [ $parnew = "System" ] ; then
			sudo /sbin/reboot
		elif [ $parnew = "MRSystem" ] ; then
			sudo /etc/init.d/mrsystem restart
		elif [ $parnew = "Anhalten" ] ; then
			sudo /sbin//halt
		fi
	elif [ $parnam = "client_cc" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrcc"
			enable_stop "mrcc"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrcc"
			disable_stop "mrcc"
		fi
	elif [ $parnam = "client_cs2eth" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrcs2eth"
			enable_stop "mrcs2eth"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrcs2eth"
			disable_stop "mrcs2eth"
		fi
	elif [ $parnam = "client_cs2sl" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrcs2sl"
			enable_stop "mrcs2sl"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrcs2sl"
			disable_stop "mrcs2sl"
		fi
	elif [ $parnam = "client_ms1" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrms1"
			enable_stop "mrms1"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrms1"
			disable_stop "mrms1"
		fi
	elif [ $parnam = "client_ms2" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrms2"
			enable_stop "mrms2"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrms2"
			disable_stop "mrms2"
		fi
	elif [ $parnam = "client_ms24l" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrms24l"
			enable_stop "mrms24l"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrms24l"
			disable_stop "mrms24l"
		fi
	elif [ $parnam = "client_slcan" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrslcan"
			enable_stop "mrslcan"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrslcan"
			disable_stop "mrslcan"
		fi
	elif [ $parnam = "client_zentrale" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "mrzentrale"
			enable_stop "mrzentrale"
		elif [ $parnew = "disable" ] ; then
			disable_start "mrzentrale"
			disable_stop "mrzentrale"
		fi
	elif [ $parnam = "client_gpios88" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "startmrgpios88"
			enable_stop "mrgpios88"
		elif [ $parnew = "disable" ] ; then
			disable_start "startmrgpios88"
			disable_stop "mrgpios88"
		fi
	elif [ $parnam = "drehscheibe" ] ; then
		if [ $parnew = "enable" ] ; then
			enable_start "drehscheibe"
			enable_stop "drehscheibe"
		elif [ $parnew = "disable" ] ; then
			disable_start "drehscheibe"
			disable_stop "drehscheibe"
		fi
	elif [ $parnam = "rocrail" ] ; then
		if [ $parnew = "enable" ] ; then
			sudo sed -i -e "s;^#      nohup;      nohup;" $rocraild
			sudo sed -i -e "s;^#      kill;      kill;" $rocraild
		elif [ $parnew = "disable" ] ; then
			sudo sed -i -e "s;^      nohup;#      nohup;" $rocraild
			sudo sed -i -e "s;^      kill;#      kill;" $rocraild
		fi
	fi
fi
